/* All Rights Reserved */

#import "Document.h"
#import <AppKit/AppKit.h>

@implementation Document

- (void) awakeFromNib
{
  if (isRichText)
    [textView replaceCharactersInRange: NSMakeRange(0, 0)
                               withRTF: data];
  else
    {
      NSString * string = [[[NSString alloc]
        initWithData: data encoding: NSUTF8StringEncoding]
        autorelease];

      [textView replaceCharactersInRange: NSMakeRange(0, 0)
                              withString: string];
    }

  DESTROY(data);
}

- (BOOL) loadDataRepresentation: (NSData *) aData ofType: (NSString *) aType
{
  if ([aType isEqualToString: @"rich text"])
    isRichText = YES;
  else
    isRichText = NO;

  ASSIGN(data, aData);

  return YES;
}

- (NSData *) dataRepresentationOfType: (NSString *) aType
{
  if (isRichText)
    {
      return [textView RTFFromRange: NSMakeRange(0,
        [[textView textStorage] length])];
    }
  else
    {
      return [[textView string] dataUsingEncoding:
        NSUTF8StringEncoding];
    }
}

- (NSString *) windowNibName
{
  return @"Document";
}

@end
